/*******************************************************************************
 * This file is part of Jake Todaro and Pragathi Balasubramanian's MQP.
 * Software Process Configurator MQP
 * Advised by Professor Gary Pollice
 *
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 *
 * Contributors:
 *    Jake Todaro
 *******************************************************************************/
package configurator;

import java.util.List;

import asset.Asset;

import dialog.AnswerSet;

/**
 * This interface is responsible for selecting assets relevant to
 * the users responses
 * 
 * @author jake todaro
 *
 */
public interface AssetMatcher {
	/**
	 * return a list of assets relevant to the users answer set
	 * 
	 * @param answerSet - the users answer set
	 * 
	 * @return a list of assets relevant to the users answer set
	 */
	public List<Asset> findRelevantAssets(AnswerSet answerSet);
}
