package booleanExpression;

import java.util.LinkedList;
import java.util.List;

import dialog.Answer;
import dialog.Dialog;
import dialog.Question;

public class BooleanExpression{
	
	final static TrueBooleanAtom TRUE = new TrueBooleanAtom();
	final static FalseBooleanAtom FALSE = new FalseBooleanAtom();
	
	public static BooleanValue not(BooleanValue atom){
		
		if(atom instanceof Answer){

			final Question parentQuestion = ((Answer)atom).getParentQuestion();
			
			//the question must be asked and not have been answered a certain way
			//it is not sufficient enough to say return true if this answer is not in the answer set
			
			final List<Answer> parentAnswers = new LinkedList<Answer>();
			for(int i = 1; i <= parentQuestion.getNumberOfAnswers(); i++){
				parentAnswers.add(parentQuestion.getAnswer(i));
			}
			parentAnswers.remove((Answer)atom);
			
			parentQuestion.getAnswerList();
			parentAnswers.remove((Answer)atom);

			//if any of these are in the answer set, the question was answered appropriately
			for(int i = 0; i < parentAnswers.size(); i++){
				if(Dialog.getAnswerSet().contains(parentAnswers.get(i))){
					return TRUE;
				}
			}
			
			return FALSE;
		}
		else{
			if (atom.value()){
				return FALSE;
			}
			else{
				return TRUE;
			}
		}
	}
	
	public static BooleanValue and(List<BooleanValue> atoms){
		for(int i = 0; i < atoms.size(); i++){
			if(!atoms.get(i).value()){
				return FALSE;
			}
		}
		return TRUE;
	}
	
	public static BooleanValue or(List<BooleanValue> atoms){
		for(int i = 0; i < atoms.size(); i++){
			if(atoms.get(i).value()){
				return TRUE;
			}
		}
		return FALSE;
	}

}
