package app;

import java.util.LinkedList;

import dialog.Answer;
import dialog.AnswerSet;
import dialog.SubDialog;
import dialog.DialogController;
import dialog.OrRequirement;
import dialog.Question;

public class SampleDialog {
	
static SubDialog initializeDialog(){
		
		SubDialog dialog = new SubDialog("dialog");

		Question one = new Question(1, "What is the type of your project?");
		one.addAnswer(new Answer("Financial application"));
		one.addAnswer(new Answer("Military C3 system"));
		one.addAnswer(new Answer("IT reporting application"));
		one.addAnswer(new Answer("Software development tool"));
		one.addAnswer(new Answer("Medical records and reports"));
		one.addAnswer(new Answer("Embeded medical software"));
		one.addAnswer(new Answer("other"));
		
		Question two = new Question(2, "How many developers on the team?");
		two.addAnswer(new Answer("1-5"));
		two.addAnswer(new Answer("6-10"));
		two.addAnswer(new Answer("10-20"));
		two.addAnswer(new Answer("20-50"));
		two.addAnswer(new Answer("More than 50"));
		
		Question three = new Question(3, "How many non-developers (product managers, project managers, testers, system administrators, requirements specifiers) on the team?");
		three.addAnswer(new Answer("None"));
		three.addAnswer(new Answer("1-5"));
		three.addAnswer(new Answer("6-10"));
		three.addAnswer(new Answer("More than 10"));
		
		Question four = new Question(4, "Is this project part of a larger system?");
		four.addAnswer(new Answer("Yes"));
		four.addAnswer(new Answer("No"));

		Question five = new Question(5, "Does this project contribute a complete module / subsystem, or does it contribute one or more features?");
		five.addAnswer(new Answer("Contributes a complete module / subsystem"));
		five.addAnswer(new Answer("Contributes features"));
		
		Question six = new Question(6, "A projects process has many components. Which are you interested in configuring?");
		six.addAnswer(new Answer("Requirements"));
		six.addAnswer(new Answer("Design"));
		six.addAnswer(new Answer("Implementation"));
		six.addAnswer(new Answer("Project management and administration"));
		six.addAnswer(new Answer("Testing"));
		six.addAnswer(new Answer("Release engineering"));
		six.addAnswer(new Answer("General documentation"));
		
		Question seven = new Question(7, "Does your company have a requirements specification  methodology that your project must follow?");
		seven.addAnswer(new Answer("Yes"));
		seven.addAnswer(new Answer("No"));
		seven.addAskingRequirement(six.getAnswer(1));
		
		Question eight = new Question(8, "Does your company have a requirements specification style that is used to provide your project with requirements?");
		eight.addAnswer(new Answer("Yes"));
		eight.addAnswer(new Answer("No"));
		eight.addAskingRequirement(seven.getAnswer(2));
		
		Question nine = new Question(9, "Which type of requirement approach do you prefer?");
		nine.addAnswer(new Answer("Very formal"));
		nine.addAnswer(new Answer("Less formal, but rigorous"));
		nine.addAnswer(new Answer("Less formal, not rigorous"));
		nine.addAnswer(new Answer("Informal"));
		nine.addAnswer(new Answer("I don't have a preference"));
		nine.addAskingRequirement(eight.getAnswer(2));
		
		Question ten = new Question(10, "Do you have mostly functional requirements that you must capture and analyze?");
		ten.addAnswer(new Answer("Yes"));
		ten.addAnswer(new Answer("No"));
		LinkedList<Answer> tenReqs = new LinkedList<Answer>();
		for(int i = 2; i <= 5; i++)
			tenReqs.add(nine.getAnswer(i));
		ten.addAskingRequirement(new OrRequirement(tenReqs));
		
		Question eleven = new Question(11, "Who is responsible for specifying the requirements? These specifiers may represent other stakeholders, but they have the responsibility of writing the requirements specifications.");
		eleven.addAnswer(new Answer("The customer"));
		eleven.addAnswer(new Answer("Marketing"));
		eleven.addAnswer(new Answer("Developers"));
		eleven.addAnswer(new Answer("Sales force"));
		eleven.addAnswer(new Answer("Other"));
		eleven.addAskingRequirement(six.getAnswer(1));
		
		Question twelve = new Question(12, "Are the requirements specifiers part of your team?");
		twelve.addAnswer(new Answer("Yes"));
		twelve.addAnswer(new Answer("No"));
		LinkedList<Answer> twelveReqs = new LinkedList<Answer>();
		twelveReqs.add(eleven.getAnswer(1));
		twelveReqs.add(eleven.getAnswer(2));
		twelveReqs.add(eleven.getAnswer(4));
		twelveReqs.add(eleven.getAnswer(5));
		twelve.addAskingRequirement(new OrRequirement(twelveReqs));
		
		Question thirteen = new Question (13, "Is your team co-located");
		thirteen.addAnswer(new Answer("Yes, in the same building"));
		thirteen.addAnswer(new Answer("Yes, ion the same campus"));
		thirteen.addAnswer(new Answer("No, but in the same town or geographical area"));
		thirteen.addAnswer(new Answer("No, but in the same time zone"));
		thirteen.addAnswer(new Answer("No, across multiple time zones"));
		
		Question fourteen = new Question(14, "How frequently is the development team normally able to communicate with the requirements specifiers?");
		fourteen.addAnswer(new Answer("Several times a day"));
		fourteen.addAnswer(new Answer("Daily"));
		fourteen.addAnswer(new Answer("Weekly"));
		fourteen.addAnswer(new Answer("By pre-determined appointment (usually planned several days in advance)"));
		LinkedList<Answer> fourteenReqs = new LinkedList<Answer>();
		for(int i = 2; i <= 5; i++)
			fourteenReqs.add(nine.getAnswer(i));
		fourteen.addAskingRequirement(new OrRequirement(fourteenReqs));

		Question fifteen = new Question (15, "Does your project have to produce a user interface?");
		fifteen.addAnswer(new Answer("Yes"));
		fifteen.addAnswer(new Answer("No"));
		
		Question sixteen = new Question (16, "What type of user interface do you have to produce?");
		sixteen.addAnswer(new Answer("Graphical (includes command line)"));
		sixteen.addAnswer(new Answer("Specialized I/O devices (trackball, video goggles, etc.)"));
		sixteen.addAnswer(new Answer("Interface to sensors and actuators"));
		sixteen.addAnswer(new Answer("Web application"));
		sixteen.addAskingRequirement(fifteen.getAnswer(2));
		
		Question seventeen = new Question (17, "How complex do you expect the graphical interface to be?");
		seventeen.addAnswer(new Answer("Very simple (command line or minimal GUI)"));
		seventeen.addAnswer(new Answer("Moderately complex (uses basic GUI elements, but requires moderately complex sequences of actions)"));
		seventeen.addAnswer(new Answer("Very complex (intricate sequences of actions or specialized GUI elements)"));
		seventeen.addAnswer(new Answer("Not sure"));
		seventeen.addAskingRequirement(sixteen.getAnswer(1));
		
		Question eighteen = new Question (18, "Does the software for the specialized I/O devices exist?");
		eighteen.addAnswer(new Answer("Yes"));
		eighteen.addAnswer(new Answer("No"));
		eighteen.addAskingRequirement(sixteen.getAnswer(2));
		
		Question nineteen = new Question (19, "Do you need to write special software to interface with the sensors and actuators?");
		nineteen.addAnswer(new Answer("No"));
		nineteen.addAnswer(new Answer("Yes"));
		nineteen.addAnswer(new Answer("We have to customize existing software"));
		nineteen.addAnswer(new Answer("Not sure"));
		nineteen.addAskingRequirement(sixteen.getAnswer(3));
		
		Question twenty = new Question (20, "Are you creating a Web site or adding to one?");
		twenty.addAnswer(new Answer("Creating a new Web site"));
		twenty.addAnswer(new Answer("Adding to an existing Web site"));
		twenty.addAskingRequirement(sixteen.getAnswer(4));
		
		Question twentyone = new Question (21, "How would you like to specify functional requirements?");
		twentyone.addAnswer(new Answer("Use cases"));
		twentyone.addAnswer(new Answer("User stories"));
		twentyone.addAnswer(new Answer("Scenarios"));
		twentyone.addAnswer(new Answer("Not sure"));
		LinkedList<Answer> twentyoneReqs = new LinkedList<Answer>();
		for(int i = 2; i <= 5; i++)
			twentyoneReqs.add(nine.getAnswer(i));
		twentyone.addAskingRequirement(new OrRequirement(twentyoneReqs));		
		
		Question twentytwo = new Question (22, "Is there a specific sequence of steps that users follow for your projects application?");
		twentytwo.addAnswer(new Answer("Yes"));
		twentytwo.addAnswer(new Answer("No"));
		twentytwo.addAnswer(new Answer("Not sure"));
		twentytwo.addAskingRequirement(twentyone.getAnswer(4));
		
		Question twentythree = new Question (23, "Will your project implement features/functionality that will be used to make up a complete scenario for users interacting with the final system?");
		twentythree.addAnswer(new Answer("Yes"));
		twentythree.addAnswer(new Answer("No"));
		twentythree.addAnswer(new Answer("Not sure"));
		LinkedList<Answer> twentythreeReqs = new LinkedList<Answer>();
		twentythreeReqs.add(five.getAnswer(2));
		twentythreeReqs.add(twentytwo.getAnswer(3));
		twentythree.addAskingRequirement(new OrRequirement(twentythreeReqs));
		
		Question twentyfour = new Question (24, "Are you provided with a use case that your project must implement all or some part? ");
		twentyfour.addAnswer(new Answer("Yes"));
		twentyfour.addAnswer(new Answer("No"));
		LinkedList<Answer> twentyfourReqs = new LinkedList<Answer>();
		twentyfourReqs.add(eight.getAnswer(1));
		twentyfourReqs.add(twentythree.getAnswer(3));
		twentyfour.addAskingRequirement(new OrRequirement(twentyfourReqs));
		
		Question twentyfive = new Question (25, "Do your developers all work on a single feature or scenario at the same time?");
		twentyfive.addAnswer(new Answer("Yes"));
		twentyfive.addAnswer(new Answer("No"));
		twentyfive.addAnswer(new Answer("Sometimes"));
		twentyfive.addAnswer(new Answer("Not sure"));
		LinkedList<Answer> twentyfiveReqs = new LinkedList<Answer>();
		twentyfiveReqs.add(two.getAnswer(1));
		twentyfiveReqs.add(two.getAnswer(2));
		twentyfiveReqs.add(twentyfour.getAnswer(1));
		twentyfive.addAskingRequirement(new OrRequirement(twentyfiveReqs));
		
		Question twentysix = new Question (26, "With which requirements specifications does your team have experience?");
		twentysix.addAnswer(new Answer("Use cases"));
		twentysix.addAnswer(new Answer("User stories"));
		twentysix.addAnswer(new Answer("Behavior driven scenarios"));
		twentysix.addAnswer(new Answer("Other"));
		twentysix.addAskingRequirement(twentyfive.getAnswer(1));
		LinkedList<Answer> twentysixReqs = new LinkedList<Answer>();
		twentysixReqs.add(twentyfive.getAnswer(3));
		twentysixReqs.add(twentyfive.getAnswer(4));
		twentysix.addAskingRequirement(new OrRequirement(twentysixReqs));
		
		Question twentyseven = new Question (27, "What type of requirements specification does your company use?");
		twentyseven.addAnswer(new Answer("Use cases"));
		twentyseven.addAnswer(new Answer("User stories"));
		twentyseven.addAnswer(new Answer("Behavior driven scenarios"));
		twentyseven.addAnswer(new Answer("Software Requirement Specification (SRS)"));
		twentyseven.addAnswer(new Answer("Other"));
		twentyseven.addAskingRequirement(eight.getAnswer(1));
		
		Question twentyeight = new Question (28, "How experienced is your team with user stories?");
		twentyeight.addAnswer(new Answer("Very experienced"));
		twentyeight.addAnswer(new Answer("Some experience"));
		twentyeight.addAnswer(new Answer("None or very little"));
		twentyeight.addAskingRequirement(twentysix.getAnswer(2));
		twentyeight.addAskingRequirement(twentyseven.getAnswer(2));
		
		dialog.addQuestion(one);
		dialog.addQuestion(two);
		dialog.addQuestion(three);
		dialog.addQuestion(four);
		dialog.addQuestion(five);
		dialog.addQuestion(six);
		dialog.addQuestion(seven);
		dialog.addQuestion(eight);
		dialog.addQuestion(nine);
		dialog.addQuestion(ten);
		dialog.addQuestion(eleven);
		dialog.addQuestion(twelve);
		dialog.addQuestion(thirteen);
		dialog.addQuestion(fourteen);
		dialog.addQuestion(fifteen);
		dialog.addQuestion(sixteen);
		dialog.addQuestion(seventeen);
		dialog.addQuestion(eighteen);
		dialog.addQuestion(nineteen);
		dialog.addQuestion(twenty);
		dialog.addQuestion(twentyone);
		dialog.addQuestion(twentytwo);
		dialog.addQuestion(twentythree);
		dialog.addQuestion(twentyfour);
		dialog.addQuestion(twentyfive);
		dialog.addQuestion(twentysix);
		dialog.addQuestion(twentyseven);
		dialog.addQuestion(twentyeight);
		
		return dialog;
	}
	
	public static void run () throws Exception{
		AnswerSet answers = new AnswerSet();
		DialogController dm = new DialogController();
		dm.runSubDialog(initializeDialog(), answers);
	}
}
