/*******************************************************************************
 * This file is part of Jake Todaro and Pragathi Balasubramanian's MQP.
 * Software Process Configurator MQP
 * Advised by Professor Gary Pollice
 *
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 *
 * Contributors:
 *    Jake Todaro
 *******************************************************************************/

package dialog.trigger;


/** this class represents a simple Trigger. It has only
 * one TriggerClause, and is satisfied if its TriggerClause
 * is satisfied. 
 * 
 * @author jake todaro
 * 
 * @version 12/15/11
 */
public class SimpleTrigger extends Trigger {

	/** constructor initializes the fields
	 * 
	 * @param triggerClause - the TriggerClause for this Trigger
	 */
	public SimpleTrigger(TriggerClause triggerClause){
		triggerClauses.add(triggerClause);
	}
	
	public TriggerClause getTriggerClause(){
		return triggerClauses.get(0);
	}
	
	@Override
	public boolean isSatisfied() {
		return getTriggerClause().isSatisfied();
	}
}