/*******************************************************************************
 * This file is part of Jake Todaro and Pragathi Balasubramanian's MQP.
 * Software Process Configurator MQP
 * Advised by Professor Gary Pollice
 *
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 *
 * Contributors:
 *    Jake Todaro
 *******************************************************************************/

package dialog.trigger;

/** this interface represents a trigger clause. a TriggerClause
 * is a single clause that is either satisfied or not.
 * single Answers and Assets are TriggerClauses, as are WeightedObjects
 * 
 * @author jake todaro
 * 
 *@version 12/15/11
 */

public interface TriggerClause{
	
	/** determine if this TriggerClause is satisfied
	 * 
	 * @return true if this TriggerClause is satisfied
	 */
	boolean isSatisfied();
}
