/*******************************************************************************
 * This file is part of Jake Todaro and Pragathi Balasubramanian's MQP.
 * Software Process Configurator MQP
 * Advised by Professor Gary Pollice
 *
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 *
 * Contributors:
 *    Jake Todaro
 *******************************************************************************/

package booleanExpression;

/** this interface represents a boolean value. a BooleanValue can be
 * a single atomic element, or an expression like an and, or, or not statement,
 * and are either true or false. triggers in the Dialog are parsed and
 * transformed into BooleanValues to be evaluated while running the Dialog.
 * 
 * @author jake todaro
 *
 *@version 12/23/11
 */

public interface BooleanValue {
	
	/** return the value of this BooleanValue
	 * 
	 * @return the value of this BooleanValue
	 */
	boolean value();
}
