/*******************************************************************************
 * This file is part of Jake Todaro and Pragathi Balasubramanian's MQP.
 * Software Process Configurator MQP
 * Advised by Professor Gary Pollice
 *
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 *
 * Contributors:
 *    Jake Todaro
 *******************************************************************************/

package dialogView.controller;

import java.util.Enumeration;

import javax.swing.AbstractButton;
import javax.swing.JRadioButton;


import dialog.Dialog;
import dialog.Question;
import dialogView.DialogView;

/** this is the main controller class for a QuestionView
 * 
 * @author jake todaro
 * @author pragathi balasubramanian
 * @version 1/16/12
 */
public class Controller {
	
	private static Question currentQuestion = Dialog.getNextQuestion();


	/** return the index of the selected radio button
	 * 
	 * @return the index of the selected radio button
	 */
	public static int getRadioSelectedIndex(){
		int selectedIndex = -1;
		int i = 0;
		for (Enumeration<AbstractButton> e=DialogView.answers.getElements(); e.hasMoreElements(); ) {
	        JRadioButton b = (JRadioButton)e.nextElement();
	        if (b.isSelected()) {
	            selectedIndex = i;
	        }
	        i++;
	    }
		
		return selectedIndex;
	

	} 
	
	/** return the currentQuestion
	 * 
	 * @return the currentQuestion
	 */
	public static Question getCurrentQuestion(){
		return currentQuestion;
	}
	
	/** set the currentQuestion
	 * 
	 * @param question - the currentQuestion
	 */
	public static void setCurrentQuestion(Question question){
		currentQuestion = question;
	}
	
	

}
