/*******************************************************************************
 * This file is part of Jake Todaro and Pragathi Balasubramanian's MQP.
 * Software Process Configurator MQP
 * Advised by Professor Gary Pollice
 *
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 *
 * Contributors:
 *    Jake Todaro
 *******************************************************************************/

package dialogView.controller;

import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;

import dialog.Dialog;
import dialogView.DialogView;

/** this class is the action listener for the next button in a DialogView.
 * clicking the next button submits the users answer and displays the next question.
 * 
 * @author jake todaro
 * @author pragathi balasubramanian
 * @version 3/16/12
 */
public class NextButtonListener implements ActionListener {

	@Override
	public void actionPerformed(ActionEvent e) {
		int selectedIndex = Controller.getRadioSelectedIndex();
		if( selectedIndex > -1){
			
			Controller.getCurrentQuestion().getAnswerList().get(selectedIndex).select();
			
			Controller.setCurrentQuestion(Dialog.getNextQuestion());

			DialogView.renderQuestionView();
		}
	}
}
