/*******************************************************************************
 * This file is part of the Software Process Configurator MQP
 * Project Members: Wesley Ripley, Adam Talbot.
 * Project Advisor: Gary Pollice
 *
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 *
 * Contributors:
 *    Wesley Ripley, Adam Talbot
 *******************************************************************************/

package dsl;

import value.valueData.ValueType;
import static dsl.antlr.DSLParser.*;

/**
 * Utility class for the DSL.
 * @author Wesley Ripley, Adam Talbot
 * @version 2/20/13
 */
public class DSLUtil {

	/**
	 * Finds the ValueType based on the given token
	 * @param tokenType the type of Token to assess
	 * @return a ValueType enumeration
	 */
	public static ValueType getValueType(int tokenType) {
		switch(tokenType) {
		case TEXT:
		case STRING:
			return ValueType.STRING;
		case INTEGER:
			return ValueType.INT;
		case TRUE:
		case FALSE:
			return ValueType.BOOLEAN;
		default:
			throw new IllegalArgumentException("Invalid value token");
			
		}
	}
}
