/*******************************************************************************
 * This file is part of Jake Todaro and Pragathi Balasubramanian's MQP.
 * Software Process Configurator MQP
 * Advised by Professor Gary Pollice
 *
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 *
 * Contributors:
 *    Jake Todaro
 *******************************************************************************/

package dialog;

import static org.junit.Assert.*;

import org.junit.BeforeClass;
import org.junit.Test;


public class SubDialogEqualsTest {
	
	private static SubDialog d1, d2;
	
	@BeforeClass
	public static void setup(){
		d1 = new SubDialog("title");
		d2 = new SubDialog("title");
	}
	
	@Test
	public void testSubDialogNoQuestions(){
		assertTrue(d1.equals(d2));
		
		d2 = new SubDialog(" ");
		assertFalse(d1.equals(d2));
	}
	
	@Test
	public void testSubDialogNoAnswersNoTriggers(){
		Question q1, q2;
		q1 = new Question("question");
		q1.setID("1");
		q2 = new Question("question");
		q2.setID("1");
		
		assertTrue(q1.equals(q2));
		
		q2 = new Question("question");
		q2.setID("2");
		assertFalse(q1.equals(q2));
		
		q2 = new Question(" ");
		q2.setID("1");
		assertFalse(q1.equals(q2));
		
		q2 = new Question("question");
		q2.setID("1");
		d1.addQuestion(q1);
		d1.addQuestion(q2);
		assertTrue(q1.equals(q2));
		
		d2.addQuestion(q2);
		assertFalse(q1.equals(q2));
	}
	
	
	

}
